/****************************************************************************/
/****       File Format Converter ALTERA MAX2PLUS to C                   ****/
/****       ROW BINARY file (.rpf) to a C include file                   ****/
/****       (c)(p) AVL/PEE by Frank Rodler  (11.97)  V0.0                ****/
/****************************************************************************/

#include  <conio.h>
#include  <stdlib.h>
#include  <stdio.h>
#include  <string.h>
#include  <process.h>
#include  <dos.h>
#include  <time.h>

typedef unsigned char BYTE;
typedef unsigned long  WORD;
typedef unsigned int  BOOL;
#define TRUE         0x1
#define FALSE        0
#define ESC          0x1B

/*************************************************************************/
/*  FUNCTION PROTOTYPING                                                 */
/*************************************************************************/

/*************************************************************************/
/*  MAIN of Console Application                                          */
/*************************************************************************/

int main (int argc, char **argv)
{
   char sfile[16] ;
   char dfile[16] ;
   FILE *SourceFile ;
   FILE *DestFile ;
   BYTE rd[1] ;
   int i ;
   size_t cnt ;
   int overall_cnt = 0 ;
   long curpos ;
   long filelen ;
   int taste ;
   time_t now ;
   BOOL quiet = FALSE ;
   char now_string[40] ;

   /* Source file name definition */
   if(argc == 1)
   {
      printf("No input file specified!!! \n") ;
      printf("   type : RBF2C filename_without_extension \n\n") ;
      return(1) ;
   }
   else
   {
      if(argc == 3) quiet = TRUE ;
      sprintf(sfile,"%s.rbf",*(argv+1)) ;
      sprintf(dfile,"%sc.inc",*(argv+1)) ;
      if(quiet==FALSE)
      {
       	system("cls") ;
        printf(" MAX2PLUS   R B F - F O R M A T  to  C - I N C L U D E    C O N V E R T E R \n") ; 
        printf("                                 V 0.0 \n\n") ; 
		printf("Source File : %s\nDestination File : %s\n\n",sfile,dfile) ;
        printf("Ok to proceed (Y/N) :") ;
        taste = getch() ;
        printf("\n") ;
        if((taste == 'Y') || (taste == 'y')) ;
        else return(1) ;
      }
   }

   if ((SourceFile = fopen (sfile,"rb")) == NULL )
   {
      printf("Source does not exist !!!\n") ;
      return(1) ;
   }
   if ((DestFile = fopen (dfile,"wt")) == NULL )
   {
      printf("Cannot open destination file!!!\n") ;
      return(1) ;
   }
   fseek(SourceFile,0L,SEEK_END) ;
   filelen = ftell(SourceFile) ;
   fseek(SourceFile,0L,SEEK_SET) ;

   time(&now) ;
   i = sprintf(now_string,"%s",ctime(&now)) ;
   now_string[i-1] = 0x0;

   i = fprintf(DestFile,"/*------------------------------------------------------------*/\n") ;
   i = fprintf(DestFile,"/*-- %s ",dfile) ;
   while(i <= 61) {fprintf(DestFile," ") ; i++ ;} fprintf(DestFile,"*/\n") ;
   i = fprintf(DestFile,"/*-- This file was generated from %s as input file",sfile) ;
   while(i <= 61) {fprintf(DestFile," ") ; i++ ;} fprintf(DestFile,"*/\n") ;
   i = fprintf(DestFile,"/*-- (c)(p) AVL/PEE by Frank Rodler 11.97                     */\n") ;              
   i = fprintf(DestFile,"/*-- Generation time : %s",now_string) ;
   while(i <= 61) {fprintf(DestFile," ") ; i++ ;} fprintf(DestFile,"*/\n") ;
   i = fprintf(DestFile,"/*------------------------------------------------------------*/\n\n") ;
   fprintf(DestFile,"const ga_count = %ld ;\n",filelen) ;
   fprintf(DestFile,"unsigned char ga_field [%ld] = {\n   ",filelen) ;

   for(i=1;i<17;i++)
   {
      overall_cnt++ ;
      cnt = fread(rd,1,1,SourceFile) ;
      if(cnt == 0)
      {
         if(quiet==FALSE) printf("\nFile ending\n") ;
         break ;
      }
      /* printf("Byte ist :$%2.2X \n",rd[0]) ; */
      if(i==16)
      {
         fprintf(DestFile,"0x0%2.2X,\n   ",rd[0]) ;
         i = 0 ;
         if(quiet==FALSE) printf(".") ;
      }
      else
      {
         fprintf(DestFile,"0x0%2.2X,",rd[0]) ;
      }
   }
   curpos = ftell(DestFile) ;
   curpos-- ;
   fseek(DestFile,curpos,SEEK_SET) ;
   fprintf(DestFile,"} ;\n") ;
   fprintf(DestFile,"/* End of include file : %s */\n",dfile) ;
   fclose(SourceFile) ;
   fclose(DestFile) ;

	return(0) ;
}

